/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.veranstaltung.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class VeranstaltungTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final java.lang.String externeId;
    public java.lang.String getExterneId(){
      return externeId;
    }
  protected final de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK;
    public de.ivu.elect.business.gebietsbaum.entity.GebietTK getGebietTK(){
      return gebietTK;
    }

  public VeranstaltungTK(
java.lang.String externeId
,   de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK
  ) {
    super();


      this.externeId = externeId;
        this.gebietTK = gebietTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((externeId == null) ? 0 : externeId.hashCode());
        
                    result = result + ((gebietTK == null) ? 0 : gebietTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof VeranstaltungTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        VeranstaltungTK other = (VeranstaltungTK) obj;

                if (externeId == null) {
          if (other.externeId != null) {
            return false;
          }
        } else if (!externeId.equals(other.externeId)) {
          return false;
        }
        
                if (gebietTK == null) {
          if (other.gebietTK != null) {
            return false;
          }
        } else if (!gebietTK.equals(other.gebietTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return VeranstaltungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(VeranstaltungConstants.MESSAGE_KEY_ENTITY_EINZAHL, VeranstaltungConstants.MESSAGE_KEY_EXTERNE_ID_EINZAHL, externeId));
        
        return result;
      }


            @Override
            public String toString() {
            return "VeranstaltungTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"externeId="+externeId
                                        +", gebietTK="+gebietTK
            
            ;
                            return result;
            
            }
  
  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
    + messages.getMessageForMessageKey(VeranstaltungConstants.MESSAGE_KEY_EXTERNE_ID_EINZAHL) + "=" + externeId
    + ", " +  toStringLokalisiert(gebietTK, messages)
                + "]"

            ;
  }

            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Veranstaltung> java.util.Map<VeranstaltungTK, E> mappeVeranstaltungNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Veranstaltung::getVeranstaltungTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Veranstaltung, VeranstaltungTK> getVeranstaltungToTKFunction() {
                return Veranstaltung::getVeranstaltungTK;
                }

}
